searchNodes=[{"doc":"This module defines the behaviour and public API for Artificery command line applications.UsageTo get started, simply use this module, and you can start defining your CLI right away:use Artificery command :hello, &quot;Say hello&quot; do option :name, :string, &quot;The name of the person to greet&quot; end ... def hello(_argv, %{name: name}) do Console.success &quot;Hello \#{name}!&quot; endThis module exports a few macros for building up complex CLI applications, so please review the documentation for more information on each, and how to use them.","ref":"Artificery.html","title":"Artificery","type":"behaviour"},{"doc":"Like option, but rather than a command switch, it defines a positional argument.Beyond the semantics of switches vs positional args, this takes the same configuration as option or defoption.Examplesargument :name, :string","ref":"Artificery.html#argument/2","title":"Artificery.argument/2","type":"macro"},{"doc":"Like argument/2, but takes either help text or a keyword list of flags.Examplesargument :name, :string, &quot;The name to use&quot; argument :name, :string, required: true","ref":"Artificery.html#argument/3","title":"Artificery.argument/3","type":"macro"},{"doc":"Like argument/3, but takes a name, type, help text and keyword list of flags.Examplesargument :name, :string, &quot;The name to use&quot;, required: true","ref":"Artificery.html#argument/4","title":"Artificery.argument/4","type":"macro"},{"doc":"Defines a new command with the given name and either help text or flags.Examplescommand :info, &quot;Displays info about stuff&quot; command :info, hidden: true","ref":"Artificery.html#command/2","title":"Artificery.command/2","type":"macro"},{"doc":"Defines a new command with the given name, flags or help text, and definition, or flags, help text, and no definition.Examplescommand :info, &quot;Displays info about stuff&quot; do ... end command :info, [hidden: true] do ... end command :info, [hidden: true], &quot;Displays info about stuff&quot; do ... end","ref":"Artificery.html#command/3","title":"Artificery.command/3","type":"macro"},{"doc":"Defines a new command with the given name, flags, help text, and definition.Examplescommand :admin, hidden: true, &quot;Does admin stuff&quot; do ... end","ref":"Artificery.html#command/4","title":"Artificery.command/4","type":"macro"},{"doc":"Defines an option which can be imported into one or more commands.This is an abstract option definition, i.e. it doesn't define an option in any scope, it defines options for reuse.This macro takes the option name, type, and either help text or options.Valid types are the same as those defined in OptionParser.Examplesdefoption :verbose, :boolean, &quot;Turns on verbose output&quot; defoption :verbose, :boolean, hidden: true","ref":"Artificery.html#defoption/3","title":"Artificery.defoption/3","type":"macro"},{"doc":"Like defoption/3, but takes the option name, type, help, and flags.Examplesdefoption :verbose, :boolean, &quot;Turns on verbose output&quot;, hidden: true","ref":"Artificery.html#defoption/4","title":"Artificery.defoption/4","type":"macro"},{"doc":"Imports an option defined via defoption into the current scope.You may optionally override flags for a given option by passing a keyword list as a second argument.You are not allowed to override the type of the option, but you may override the help text, by passing help: &quot;...&quot; as an override. If you need to override the type, it is better if you use option/3 or option/4Examplesdefoption :name, :string, &quot;Name of person&quot; command :hello, &quot;Says hello&quot; do # Import with no overrides option :name # Import with overrides option :name, required: true, alias: :n # Import and customize help text option :name, help: &quot;Name of the person to greet&quot; end","ref":"Artificery.html#option/1","title":"Artificery.option/1","type":"macro"},{"doc":"When used in the following form:option :foo, :stringThis defines a new option, foo, of type string, with no help or flags defined.When used like this:option :foo, required: trueIt imports an option definition (as created via defoption) and provides overrides for the original definition.","ref":"Artificery.html#option/2","title":"Artificery.option/2","type":"macro"},{"doc":"Similar to defoption, but defines an option inline.Options defined this way apply either to the global scope, if they aren't nested within a command macro, or to the scope of the command they are defined in.See defoption for usage examples.","ref":"Artificery.html#option/3","title":"Artificery.option/3","type":"macro"},{"doc":"","ref":"Artificery.html#option/4","title":"Artificery.option/4","type":"macro"},{"doc":"","ref":"Artificery.html#c:pre_dispatch/3","title":"Artificery.pre_dispatch/3","type":"callback"},{"doc":"","ref":"Artificery.html#t:argv/0","title":"Artificery.argv/0","type":"type"},{"doc":"","ref":"Artificery.html#t:options/0","title":"Artificery.options/0","type":"type"},{"doc":"A minimal logger.","ref":"Artificery.Console.html","title":"Artificery.Console","type":"module"},{"doc":"Ask the user to provide data in response to a question.The value returned is dependent on whether a transformation is applied, and whether blank answers are accepted. By default, empty strings will return nil if no alternate default is supplied and either no validator was supplied, or it returned :ok for blank answers.If you supply a default, instead of nil, the default will be returned. Again this only applies if a blank answer is considered valid.You may validate answers by supplying a function (bound or captured) via the validator: fun option. This function will receive the raw input string supplied by the user, and should return :ok if the answer is valid, or {:error, validation_error}, where validation_error is a string which will be displayed to the user before asking them to answer the question again.You may apply a transformation to answers, so that rather than getting a string back, you get the value in a state useful for your application. You may provide a transform via the transform: fun option, and this will receive the raw input string the user provided after the validator has validated the input, if one was supplied, and if the user input was non-nil.Supply default values with the default: term option.","ref":"Artificery.Console.html#ask/2","title":"Artificery.Console.ask/2","type":"function"},{"doc":"Updates the logger configuration with the given options.","ref":"Artificery.Console.html#configure/1","title":"Artificery.Console.configure/1","type":"function"},{"doc":"Prints a debug message, only visible when verbose mode is on.","ref":"Artificery.Console.html#debug/2","title":"Artificery.Console.debug/2","type":"function"},{"doc":"Prints an error message, and then halts the process.","ref":"Artificery.Console.html#error/2","title":"Artificery.Console.error/2","type":"function"},{"doc":"Terminates the process with the given status code.","ref":"Artificery.Console.html#halt/1","title":"Artificery.Console.halt/1","type":"function"},{"doc":"Prints an info message.","ref":"Artificery.Console.html#info/2","title":"Artificery.Console.info/2","type":"function"},{"doc":"Prints a notice","ref":"Artificery.Console.html#notice/2","title":"Artificery.Console.notice/2","type":"function"},{"doc":"Provides a spinner while some long-running work is being done.Options:spinner - one of the spinners defined in Artificery.Console.SpinnerExamplesConsole.spinner &quot;Loading...&quot;, [spinner: :simple_dots] do :timer.sleep(5_000) end","ref":"Artificery.Console.html#spinner/3","title":"Artificery.Console.spinner/3","type":"macro"},{"doc":"Prints a success message","ref":"Artificery.Console.html#success/2","title":"Artificery.Console.success/2","type":"function"},{"doc":"Updates a running spinner with the provided status text.","ref":"Artificery.Console.html#update_spinner/1","title":"Artificery.Console.update_spinner/1","type":"function"},{"doc":"Prints a warning message","ref":"Artificery.Console.html#warn/2","title":"Artificery.Console.warn/2","type":"function"},{"doc":"Write text or iodata to standard output.You may optionally pass a list of styles to apply to the output, as well as the device to write to (:standard_error, or :stdio).","ref":"Artificery.Console.html#write/1","title":"Artificery.Console.write/1","type":"function"},{"doc":"","ref":"Artificery.Console.html#write/2","title":"Artificery.Console.write/2","type":"function"},{"doc":"","ref":"Artificery.Console.html#write/3","title":"Artificery.Console.write/3","type":"function"},{"doc":"Ask the user a question which requires a yes/no answer, returns a boolean.","ref":"Artificery.Console.html#yes?/1","title":"Artificery.Console.yes?/1","type":"function"},{"doc":"A printer for tabular data.","ref":"Artificery.Console.Table.html","title":"Artificery.Console.Table","type":"module"},{"doc":"Given a title, header, and rows, formats the data as a table.Takes an optional keyword list of options::padding - (integer) sets the padding around columnsThis function formats the data as iodata, it is up to the caller to print it.","ref":"Artificery.Console.Table.html#format/4","title":"Artificery.Console.Table.format/4","type":"function"},{"doc":"Given a title, header, and rows, prints the data as a table.Takes the same options as format/4.","ref":"Artificery.Console.Table.html#print/4","title":"Artificery.Console.Table.print/4","type":"function"},{"doc":"This module defines the entrypoint for Artificery command line applications, which handles argument parsing, dispatch, and help generation.","ref":"Artificery.Entry.html","title":"Artificery.Entry","type":"module"},{"doc":"Artificery Artificery is a toolkit for generating command line applications. It handles argument parsing, validation/transformation, generating help, and provides an easy way to define commands, their arguments, and options.","ref":"readme.html","title":"Artificery","type":"extras"},{"doc":"Just add Artificery to your deps:defp deps do [ # You can get the latest version information via `mix hex.info artificery` {:artificery, &quot;~&gt; x.x&quot;} ] endThen run mix deps.get and you are ready to get started!","ref":"readme.html#installation","title":"Artificery - Installation","type":"extras"},{"doc":"Let's assume you have an application named :myapp, let's define a module, MyCliModule which will be the entry point for the command line interface:defmodule MyCliModule do use Artificery endThe above will setup the Artificery internals for your CLI, namely it defines an entry point for the command line, argument parsing, and imports the macros for defining commands, options, and arguments.CommandsLet's add a simple &quot;hello&quot; command, which will greet the caller:defmodule MyCliModule do use Artificery command :hello, &quot;Says hello&quot; do argument :name, :string, &quot;The name of the person to greet&quot;, required: true end endWe've introduced two of the macros Aritificery imports: command, for defining top-level and nested commands; and argument for defining positional arguments for the current command. Note: argument can only be used inside of command, as it applies to the current command being defined, and has no meaning globally.This command could be invoked (via escript) like so: ./myapp hello bitwalker. Right now this will print an error stating that the command is defined, but no matching implementation was exported. We define that like so:def hello(_argv, %{name: name}) do Artificery.Console.notice &quot;Hello \#{name}!&quot; endNote: Command handlers are expected to have an arity of 2, where the first argument is a list of unhandled arguments/options passed on the command line, and the second is a map containing all of the formally defined arguments/options.This goes in the same module as the command definition, but you can use defdelegate to put the implementation elsewhere. The thing to note is that the function needs to be named the same as the command. You can change this however using an extra parameter to command, like so:command :hello, [callback: :say_hello], &quot;Says hello&quot; do argument :name, :string, &quot;The name of the person to greet&quot;, required: true endThe above will invoke say_hello/2 rather than hello/2.Command FlagsThere are two command flags you can set currently to alter some of Artificery's behaviour: callback: atom and hidden: boolean. The former will change the callback function invoked when dispatching a command, as shown above, and the latter, when true, will hide the command from display in the help output. You may also apply :hidden to options (but not arguments).OptionsLet's add a --greeting=string option to the hello command:command :hello, &quot;Says hello&quot; do argument :name, :string, &quot;The name of the person to greet&quot;, required: true option :greeting, :string, &quot;Sets a different greeting than \\&quot;Hello &lt;name&gt;\\!&quot;&quot; endAnd adjust our implementation:def hello(_argv, %{name: name} = opts) do greeting = Map.get(opts, :greeting, &quot;Hello&quot;) greet(greeting, name) end defp greet(greeting, name), do: Artificery.Console.notice(&quot;\#{greeting} \#{name}!&quot;)And we're done!SubcommandsWhen you have more complex command line interfaces, it is common to divide up &quot;topics&quot; or top-level commands into subcommands, you see this in things like Heroku's CLI, e.g. heroku keys:add. Artificery supports this by allowing you to nest command within another command. Artificery is smart about how it parses arguments, so you can have options/arguments at the top-level as well as in subcommands, e.g. ./myapp info --format=json processes. The options map received by the processes command will contain all of the options for commands above it.defmodule MyCliModule do use Artificery command :info, &quot;Get info about :myapp&quot; do option :format, :string, &quot;Sets the output format&quot; command :processes, &quot;Prints information about processes running in :myapp&quot; endNote: As you may have noticed above, the processes command doesn't have a do block, because it doesn't define any arguments or options, this form is supported for convenience.Global OptionsYou may define global options which apply to all commands by defining them outside command:defmodule MyCliModule do use Artificery option :debug, :boolean, &quot;When set, produces debugging output&quot; ... endNow all commands defined in this module will receive debug: true | false in their options map, and can act accordingly.Reusing OptionsYou can define reusable options via defoption/3 or defoption/4. These are effectively the same as option/3 and option/4, except they do not define an option in any context, they are defined abstractly and intended to be used via option/1 or option/2, as shown below:defoption :host, :string, &quot;The hostname of the server to connect to&quot;, alias: :h command :ping, &quot;Pings the host to verify connectivity&quot; do # With no overridden flags # option :host # With overrides option :host, help: &quot;The host to ping&quot;, default: &quot;localhost&quot; end command :query, &quot;Queries the host&quot; do # Can be shared across commands, even used globally option :host, required: true argument :query, :string, required: true endOption/Argument TransformsYou can provide transforms for options or arguments to convert them to the data types your commands desire as part of the option definition, like so:# Options option :ip, :string, &quot;The IP address of the host to connect to&quot;, transform: fn raw -&gt; case :inet.parse_address(String.to_charlist(raw)) do {:ok, ip} -&gt; ip {:error, reason} -&gt; raise &quot;invalid value for --ip, got: \#{raw}, error: \#{inspect reason}&quot; end end # Arguments argument :ip, :string, &quot;The IP address of the host to connect to&quot;, transform: ...Now the command (and any subcommands) where this option is defined will get a parsed IP address, rather than a raw string, allowing you to do the conversion in one place, rather than in each command handler.Currently this macro supports functions in anonymous form (like in the example above), or one of the following forms:# Function capture, must have arity 1 transform: &amp;String.to_atom/1 # Local function as an atom, must have arity 1 transform: :to_ip_address # Module/function/args tuple, where the raw value is passed as the first argument # This form is invoked via `apply/3` transform: {String, :to_char_list, []}Pre-Dispatch HandlingFor those cases where you need to perform some action before command handlers are invoked, perhaps to apply global behaviour to all commands, start applications, or whatever else you may need, Artificery provides a hook for that, pre_dispatch/3.This is actually a callback defined as part of the Artificery behaviour, but is given a default implementation. You can override this implementation though to provide your own pre-dispatch step.The default implementation is basically the following:def pre_dispatch(%Artificery.Command{}, _argv, %{} = options) do {:ok, options} endYou can either return {:ok, options} or raise an error, there are no other choices permitted. This allows you to extend or filter options, handle additional arguments in argv, or take action based on the current command.","ref":"readme.html#defining-a-cli","title":"Artificery - Defining a CLI","type":"extras"},{"doc":"Artificery provides a Console module which contains a number of functions for logging or writing output to standard out/standard error. A list of basic functions it provides is below:configure/1, takes a list of options which configures the logger, currently the only option is :verbositydebug/1, writes a debug message to stderr (colored cyan if terminal supports color)info/1, writes an info message to stdout (no color)notice/1, writes an informational notice to stdout (bright blue)success/1, writes a success message to stdout (bright green)warn/1, writes a warning to stderr (yellow)error/1, writes an error to stderr (red), and also halts/terminates the process with a non-zero exit codeIn addition to writing messages to the terminal, Console also provides a way to provide a spinner/loading animation while some long-running work is being performed, also supporting the ability to update the message with progress information.The following example shows a trivial example of progress, by simply reading from a file in a loop, updating the status of the spinner while it reads. There are obviously cleaner ways of writing this, but hopefully it is clear what the capabilities are.def load_data(_argv, %{path: path}) do alias Artificery.Console unless File.exists?(path) do Console.error &quot;No such file: \#{path}&quot; end # A state machine defined as a recursive anonymous function # Each state updates the spinner status and is reflected in the console loader = fn :opening, _size, _bytes_read, _file, loader -&gt; Console.update_spinner(&quot;opening \#{path}&quot;) %{size: size} = File.stat!(path) loader.(:reading, size, 0, File.open!(path), loader) :reading, size, bytes_read, file, loader -&gt; progress = Float.round((size / bytes_read) * 100) Console.update_spinner(&quot;reading..\#{progress}%&quot;) case IO.read(file) do :eof -&gt; loader.(:done, size, bytes_read, file, loader) {:error, _reason} = err -&gt; Console.update_spinner(&quot;read error!&quot;) File.close!(file) err new_data -&gt; loader.(:reading, size, byte_size(new_data), file, loader) end :done, size, bytes_read, file, loader -&gt; Console.update_spinner(&quot;done! (total bytes read \#{bytes_read})&quot;) File.close!(file) :ok end results = Console.spinner &quot;Loading data..&quot; do loader.(:opening, 0, 0, nil, loader) end case results do {:error, reason} -&gt; Console.error &quot;Failed to load data from \#{path}: \#{inspect reason}&quot; :ok -&gt; Console.success &quot;Load complete!&quot; end end","ref":"readme.html#writing-output-logging","title":"Artificery - Writing Output / Logging","type":"extras"},{"doc":"Artificery exposes some functions for working with interactive user sessions:yes?/1, asks the user a question and expects a yes/no response, returns a booleanask/2, queries the user for information they need to provideExampleLet's shoot for a slightly more amped up hello command:def hello(_argv, _opts) do name = Console.ask &quot;What is your name?&quot;, validator: &amp;is_valid_name/1 Console.success &quot;Hello \#{name}!&quot; end defp is_valid_name(name) when byte_size(name) &gt; 1, do: :ok defp is_valid_name(_), do: {:error, &quot;You must tell me your name or I can&#39;t greet you!&quot;}The above will accept any name more than one character in length, obviously not super robust, but the general idea is shown here.The ask function also supports transforming responses, and providing defaults in the case where you want to accept blank answers.Check the docs for more information!","ref":"readme.html#handling-input","title":"Artificery - Handling Input","type":"extras"},{"doc":"To use your newly created CLI as an escript, simply add the following to your mix.exs:defp project do [ ... escript: escript() ] end ... defp escript do [main_module: MyCliModule] endThe main_module to use is the module in which you added use Artificery, i.e. the module in which you defined the commands your application exposes.Finally, run mix escript.build to generate the escript executable. You can then run ./yourapp help to test it out.","ref":"readme.html#producing-an-escript","title":"Artificery - Producing An Escript","type":"extras"},{"doc":"If you want to define the CLI as part of a larger application, and consume it via custom commands in Distillery, it is very straightforward to do. You'll need to define a custom command and add it to your release configuration: # rel/config.exs release :myapp do set commands: [ mycli: &quot;rel/commands/mycli.sh&quot; ] endThen in rel/commands/mycli.sh add the following:#!/usr/bin/env bash elixir -e &quot;MyCliModule.main&quot; -- &quot;$@&quot;Since the code for your application will already be on the path in a release, we simply need to invoke the CLI module and pass in arguments. We add -- between the elixir arguments and those provided from the command line to ensure that they are not treated like arguments to our CLI. Artificery handles this, so you simply need to ensure that you add -- when invoking via elixir like this.You can then invoke your CLI via the custom command, for example, bin/myapp mycli help to print the help text.","ref":"readme.html#using-in-releases","title":"Artificery - Using In Releases","type":"extras"},{"doc":"[ ] Support validatorsI'm open to suggestions, just open an issue titled RFC: &lt;feature you are requesting&gt;.","ref":"readme.html#roadmap","title":"Artificery - Roadmap","type":"extras"},{"doc":"Copyright (c) 2018 Paul SchoenfelderLicensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"readme.html#license","title":"Artificery - License","type":"extras"}]